unit Parser;

interface

uses
  Globals,Scaner;

  procedure Expression;

implementation

procedure Match(t: TTokenType);
begin
   if Token <> t then WriteLn('Error ',TokenTypeText[t]);
   NextToken;
end;

(*   *)
function GetPriority(c: PType): byte;
begin
   Result := 0;
   case c.tok of
      tkOpenParen           : Result := 1;
      tkMinus, tkPlus       : Result := 2;
      tkMultiply, tkDivide  : Result := 3;
   end;
end;

(*         *)
procedure Expression;
var
  i,j          : integer;
  _Stack,_Temp : array of PType;
  a1,a2        : PType;
  flag         : boolean;

  procedure _StackAdd(D: PType);
  begin
    i := Length(_Stack);
    SetLength(_Stack,i+1);
    _Stack[i] := D;
  end;

  procedure _TempAdd(D: PType);
  begin
    i := Length(_Temp);
    SetLength(_Temp,i+1);
    _Temp[i] := D;
  end;

begin
  flag:=true;
  j:=0;
  while True do begin
    //   ,     
    if Token in [tkNumber,tkFloat,tkString,tkIdent,tkLoadfunc,tkLoadarray] then
    if flag then
    begin
      _StackAdd(Data);
      flag:=false;
    end else
       WriteLn('Error number');
    //    , ...
    if Token in [tkPlus,tkMinus,tkDivide,tkMultiply] then
    begin

      if flag then
        WriteLn('Error operator')
      else
         flag:=true;

      // ...  ,     ...
      if Length(_Temp) = 0 then
         _TempAdd(Data)
      else
      begin
         // ...     ,  
         //    ,     ...
         if GetPriority(Data) > GetPriority(_Temp[Length(_Temp)-1]) then
            _TempAdd(Data)
         else
         begin
            // ...      , 
            //       
            while true do
            begin
               _StackAdd(_Temp[Length(_Temp)-1]);
               SetLength(_Temp,Length(_Temp)-1);
               if Length(_Temp) = 0 then Break;
               if GetPriority(Data) > GetPriority(_Temp[Length(_Temp)-1]) then Break;
            end;
            //       
            _TempAdd(Data);
         end;
      end;
    end;
    //    ,     
    if Token in [tkOpenParen] then
    begin
      _TempAdd(Data);
      Inc(j);
    end;
    //    ,     
    //    ,     .
    //     .
    if Token in [tkCloseParen] then
    begin
      Dec(j);
      while true do
      begin
        if Length(_Temp) = 0 then Break;
        if _Temp[Length(_Temp)-1].tok = tkOpenParen then
        begin
           SetLength(_Temp,Length(_Temp)-1);
           Break;
        end;
        //  
        _StackAdd(_Temp[Length(_Temp)-1]);
        SetLength(_Temp,Length(_Temp)-1);
      end;
    end;
    NextToken;
    if Token = tkSemicolon then Break;
  end;
  if j>0 then WriteLn('Error )');
  if j<0 then WriteLn('Error (');
  //       ,   
  //   ,     
  if Length(_Temp) <> 0 then
    while Length(_Temp) <> 0 do
    begin
      _StackAdd(_Temp[Length(_Temp)-1]);
      if ((_Temp[Length(_Temp)-1].tok = tkOpenParen) AND (j=0)) then WriteLn('Error (');
      SetLength(_Temp,Length(_Temp)-1);
    end;
  _Temp:=nil;


  for i:=0 to Length(_Stack)-1 do
  begin
    Write(_Stack[i].str,' ');
  end;

  WriteLn;
  //_Stack:=nil;
  //flag:=false;

  for j:=0 to Length(_Stack)-1 do
      //   ,      ,  ...
      if _Stack[j].tok in [tkNumber,tkFloat,tkString] then
        _TempAdd(_Stack[j])
      else if _Stack[j].tok in [tkIdent,tkLoadfunc,tkLoadarray] then
      begin
        _Stack[j].null := 2;
        _TempAdd(_Stack[j]);
      end else begin
         // ...     2  
         a2 := _Temp[Length(_Temp)-1];
         a1 := _Temp[Length(_Temp)-2];
         if not ((a1.null>0) OR (a2.null>0)) then
         begin
           SetLength(_Temp,Length(_Temp)-2);
           //  
           case _Stack[j].tok of
              tkPlus    : a1.int := a1.int + a2.int;
              tkMinus   : a1.int := a1.int - a2.int;
              tkDivide  : a1.float := a1.float / a2.float;
              tkMultiply: a1.int := a1.int * a2.int;
           end;
           _TempAdd(a1);
         end else
         begin
            _Stack[j].null := 1;
            _TempAdd(_Stack[j]);
         end;
      end;

  for i:=0 to Length(_Temp)-1 do
  if _Temp[i].tok in [tkNumber,tkFloat,tkString] then
    Write(_Temp[i].int,' ')
  else
    Write(_Temp[i].str,' ');
    WriteLn;
{...}

end;

end.
